{$X+ discard function return }
UNIT	NamedMat ;


	{]=================================================[]
	||                                                 ||
	||                 TNamedMatrix                    ||
	||                                                 ||
	[]=================================================[]
	||                                                 ||
	||        Copyright  1992  TCastle Software        ||
	||                                                 ||
	||                                            ||
	||                                              ||
	||             TCastle  Software              ||
	||                                                 ||
	[]=================================================[}


INTERFACE


USES
		Matrices
	,	Objects
	;


CONST
	TNamedMatrixID	= 60001 ;	{  Stream Registry  }


TYPE
	PNamedMatrix	= ^TNamedMatrix ;
	TNamedMatrix	= OBJECT ( TMatrixObject )
		pName			: PString ;		{ name handed to Init }
		pUCNAME		: PString ;		{ Upper case of pName }
		CONSTRUCTOR	Init( aName : STRING ; wRows, wCols : WORD ) ;
		DESTRUCTOR	Done ; VIRTUAL ;	
		CONSTRUCTOR	Load ( VAR S : TStream ) ;
		PROCEDURE	Store ( VAR S : TStream ) ;
		FUNCTION		NameIs : STRING ;
		PROCEDURE	PrintIt ( VAR tFile : TEXT ) ;
							{  legible copy put on tFile  }
		FUNCTION		UCNameIs : STRING ;
	END ;


	PNamedMatrixCollection	= ^TNamedMatrixCollection ;
	TNamedMatrixCollection	= OBJECT ( TSortedCollection )
		function		Compare(Key1, Key2: Pointer): Integer; virtual;
		function		KeyOf(Item: Pointer): Pointer; virtual;
		PROCEDURE	Print ( VAR tFile : TEXT ) ;
	END ;


CONST
	pMatrices : PNamedMatrixCollection = NIL ;


PROCEDURE	RegisterTNamedMatrix ;


IMPLEMENTATION


USES
		Utility
	;


CONST
	RNamedMatrix: TStreamRec = (
		ObjType: TNamedMatrixID ;
		VmtLink: Ofs(TypeOf(TNamedMatrix)^);
		Load:    @TNamedMatrix.Load;
		Store:   @TNamedMatrix.Store
	);


PROCEDURE	RegisterTNamedMatrix ;
	BEGIN					{  RegisterTNamedMatrix  }
		RegisterType( RNamedMatrix ) ;
		RegisterTMatrixObject ;
	END ;					{  RegisterTNamedMatrix  }


{  -----  TNamedMatrix Methods  -----  }


CONSTRUCTOR	TNamedMatrix.Init ( aName : STRING ; wRows, wCols : WORD ) ;
	BEGIN					{  Init  }
		pName		:= NewStr( aName ) ;
		pUCNAME	:= NewStr( UpStr( aName ) );
		TMatrixObject.Init( wRows, wCols ) ;
	END ;					{  Init  }


DESTRUCTOR	TNamedMatrix.Done ;	{  VIRTUAL  }
	BEGIN					{  Done  }
		DisposeStr( pName );
		DisposeStr( pUCNAME );
		TMatrixObject.Done ;
	END ;					{  Done  }


CONSTRUCTOR	TNamedMatrix.Load ( VAR S : TStream ) ;
	BEGIN					{  Load  }
		pName		:= S.ReadStr ;
		pUCNAME	:= S.ReadStr ;
		TMatrixObject.Load( S ) ;
	END ;					{  Load  }


PROCEDURE	TNamedMatrix.Store ( VAR S : TStream ) ;
	BEGIN					{  Store  }
		S.WriteStr( pName ) ;
		S.WriteStr( pUCNAME ) ;
		TMatrixObject.Store( S ) ;
	END ;					{  Store  }


FUNCTION	TNamedMatrix.NameIs : STRING ;
	BEGIN					{  NameIs  }
		NameIs := pName^ ;
	END ;					{  NameIs  }


PROCEDURE	TNamedMatrix.PrintIt ( VAR tFile : TEXT ) ;
	BEGIN					{  PrintIt  }
		TMatrixObject.Print( tFile, pName^ ) ;
	END ;					{  PrintIt  }


FUNCTION	TNamedMatrix.UCNameIs : STRING ;
	BEGIN					{  UCNameIs  }
		UCNameIs := pUCNAME^ ;
	END ;					{  UCNameIs  }


{  -----  TNamedMatrixCollection Methods  -----  }


FUNCTION	TNamedMatrixCollection.Compare(Key1, Key2: Pointer): Integer;
	BEGIN					{  Compare  }
		IF  PString(Key1)^ < PString(Key2)^  THEN BEGIN
      	Compare := -1 ;
		END
		ELSE IF  PString(Key1)^ >  PString(Key2)^   THEN BEGIN
			Compare := +1 ;
		END
		ELSE BEGIN	{ they must be = }
      	Compare := 0 ;
		END ;
	END ;					{  Compare  }


FUNCTION	TNamedMatrixCollection.KeyOf(Item: Pointer): Pointer;
	BEGIN					{  KeyOf  }
		KeyOf	:= PNamedMatrix(Item)^.pUCNAME ;
	END ;					{  KeyOf  }


PROCEDURE	TNamedMatrixCollection.Print ( VAR tFile : TEXT ) ;
	PROCEDURE	PrintOne( p : PNamedMatrix  ) ; FAR ;
		BEGIN					{  PrintOne  }
			p^.PrintIt( tFile ) ;
		END ;					{  PrintOne  }
	BEGIN					{  Print  }
		ForEach( @PrintOne ) ;
	END ;					{  Print  }


{ BEGIN					{  NamedMat initialization  }
END .						{  NamedMat  }
